/*!
 * @overview es6-promise - a tiny implementation of Promises/A+.
 * @copyright Copyright (c) 2014 Yehuda Katz, Tom Dale, Stefan Penner and contributors (Conversion to ES6 API by Jake Archibald)
 * @license   Licensed under MIT license
 *            See https://raw.githubusercontent.com/jakearchibald/es6-promise/master/LICENSE
 * @version   3.0.2
 */
(function(){function U(aq){return typeof aq==="function"||(typeof aq==="object"&&aq!==null)}function M(aq){return typeof aq==="function"}function K(aq){return typeof aq==="object"&&aq!==null}var k;if(!Array.isArray){k=function(aq){return Object.prototype.toString.call(aq)==="[object Array]"}}else{k=Array.isArray}var x=k;var z=0;var am={}.toString;var y;var X;var Y=function T(ar,aq){L[z]=ar;L[z+1]=aq;z+=2;if(z===2){if(X){X(V)}else{H()}}};function F(aq){X=aq}function R(aq){Y=aq}var aa=(typeof window!=="undefined")?window:undefined;var b=aa||{};var ae=b.MutationObserver||b.WebKitMutationObserver;var u=typeof process!=="undefined"&&{}.toString.call(process)==="[object process]";var g=typeof Uint8ClampedArray!=="undefined"&&typeof importScripts!=="undefined"&&typeof MessageChannel!=="undefined";function aj(){return function(){process.nextTick(V)}}function D(){return function(){y(V)}}function G(){var at=0;var aq=new ae(V);var ar=document.createTextNode("");aq.observe(ar,{characterData:true});return function(){ar.data=(at=++at%2)}}function Q(){var aq=new MessageChannel();aq.port1.onmessage=V;return function(){aq.port2.postMessage(0)}}function m(){return function(){setTimeout(V,1)}}var L=new Array(1000);function V(){for(var ar=0;ar<z;ar+=2){var at=L[ar];var aq=L[ar+1];at(aq);L[ar]=undefined;L[ar+1]=undefined}z=0}function j(){try{var ar=require;var aq=ar("vertx");y=aq.runOnLoop||aq.runOnContext;return D()}catch(at){return m()}}var H;if(u){H=aj()}else{if(ae){H=G()}else{if(g){H=Q()}else{if(aa===undefined&&typeof require==="function"){H=j()}else{H=m()}}}}function N(){}var n=void 0;var v=1;var an=2;var I=new J();function W(){return new TypeError("You cannot resolve a promise with itself")}function t(){return new TypeError("A promises callback cannot return that same promise.")}function C(ar){try{return ar.then}catch(aq){I.error=aq;return I}}function af(av,at,ar,aq){try{av.call(at,ar,aq)}catch(au){return au}}function d(at,aq,ar){Y(function(aw){var av=false;var au=af(ar,aq,function(ax){if(av){return}av=true;if(aq!==ax){al(aw,ax)}else{ak(aw,ax)}},function(ax){if(av){return}av=true;ad(aw,ax)},"Settle: "+(aw._label||" unknown promise"));if(!av&&au){av=true;ad(aw,au)}},at)}function ag(ar,aq){if(aq._state===v){ak(ar,aq._result)}else{if(aq._state===an){ad(ar,aq._result)}else{P(aq,undefined,function(at){al(ar,at)},function(at){ad(ar,at)})}}}function s(at,aq){if(aq.constructor===at.constructor){ag(at,aq)}else{var ar=C(aq);if(ar===I){ad(at,I.error)}else{if(ar===undefined){ak(at,aq)}else{if(M(ar)){d(at,aq,ar)}else{ak(at,aq)}}}}}function al(ar,aq){if(ar===aq){ad(ar,W())}else{if(U(aq)){s(ar,aq)}else{ak(ar,aq)}}}function r(aq){if(aq._onerror){aq._onerror(aq._result)}ah(aq)}function ak(ar,aq){if(ar._state!==n){return}ar._result=aq;ar._state=v;if(ar._subscribers.length!==0){Y(ah,ar)}}function ad(ar,aq){if(ar._state!==n){return}ar._state=an;ar._result=aq;Y(r,ar)}function P(aq,aw,av,au){var at=aq._subscribers;var ar=at.length;aq._onerror=null;at[ar]=aw;at[ar+v]=av;at[ar+an]=au;if(ar===0&&aq._state){Y(ah,aq)}}function ah(av){var au=av._subscribers;var aq=av._state;if(au.length===0){return}var ax,aw,at=av._result;for(var ar=0;ar<au.length;ar+=3){ax=au[ar];aw=au[ar+aq];if(ax){E(aq,ax,aw,at)}else{aw(at)}}av._subscribers.length=0}function J(){this.error=null}var i=new J();function ap(at,aq){try{return at(aq)}catch(ar){i.error=ar;return i}}function E(ax,az,aw,at){var aq=M(aw),av,au,ay,ar;if(aq){av=ap(aw,at);if(av===i){ar=true;au=av.error;av=null}else{ay=true}if(az===av){ad(az,t());return}}else{av=at;ay=true}if(az._state!==n){}else{if(aq&&ay){al(az,av)}else{if(ar){ad(az,au)}else{if(ax===v){ak(az,av)}else{if(ax===an){ad(az,av)}}}}}}function ai(av,au){try{au(function aq(aw){al(av,aw)},function at(aw){ad(av,aw)})}catch(ar){ad(av,ar)}}function q(ar,aq){var at=this;at._instanceConstructor=ar;at.promise=new ar(N);if(at._validateInput(aq)){at._input=aq;at.length=aq.length;at._remaining=aq.length;at._init();if(at.length===0){ak(at.promise,at._result)}else{at.length=at.length||0;at._enumerate();if(at._remaining===0){ak(at.promise,at._result)}}}else{ad(at.promise,at._validationError())}}q.prototype._validateInput=function(aq){return x(aq)};q.prototype._validationError=function(){return new Error("Array Methods must be provided an Array")};q.prototype._init=function(){this._result=new Array(this.length)};var Z=q;q.prototype._enumerate=function(){var av=this;var at=av.length;var au=av.promise;var aq=av._input;for(var ar=0;au._state===n&&ar<at;ar++){av._eachEntry(aq[ar],ar)}};q.prototype._eachEntry=function(ar,aq){var au=this;var at=au._instanceConstructor;if(K(ar)){if(ar.constructor===at&&ar._state!==n){ar._onerror=null;au._settledAt(ar._state,aq,ar._result)}else{au._willSettleAt(at.resolve(ar),aq)}}else{au._remaining--;au._result[aq]=ar}};q.prototype._settledAt=function(at,aq,ar){var av=this;var au=av.promise;if(au._state===n){av._remaining--;if(at===an){ad(au,ar)}else{av._result[aq]=ar}}if(av._remaining===0){ak(au,av._result)}};q.prototype._willSettleAt=function(ar,aq){var at=this;P(ar,undefined,function(au){at._settledAt(v,aq,au)},function(au){at._settledAt(an,aq,au)})};function p(aq){return new Z(this,aq).promise}var e=p;function a(aq){var ax=this;var aw=new ax(N);if(!x(aq)){ad(aw,new TypeError("You must pass an array to race."));return aw}var at=aq.length;function av(ay){al(aw,ay)}function au(ay){ad(aw,ay)}for(var ar=0;aw._state===n&&ar<at;ar++){P(ax.resolve(aq[ar]),undefined,av,au)}return aw}var B=a;function ab(aq){var at=this;if(aq&&typeof aq==="object"&&aq.constructor===at){return aq}var ar=new at(N);al(ar,aq);return ar}var O=ab;function w(aq){var at=this;var ar=new at(N);ad(ar,aq);return ar}var ao=w;var o=0;function S(){throw new TypeError("You must pass a resolver function as the first argument to the promise constructor")}function h(){throw new TypeError("Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.")}var A=ac;function ac(aq){this._id=o++;this._state=undefined;this._result=undefined;this._subscribers=[];if(N!==aq){if(!M(aq)){S()}if(!(this instanceof ac)){h()}ai(this,aq)}}ac.all=e;ac.race=B;ac.resolve=O;ac.reject=ao;ac._setScheduler=F;ac._setAsap=R;ac._asap=Y;ac.prototype={constructor:ac,then:function(av,au){var ar=this;var at=ar._state;if(at===v&&!av||at===an&&!au){return this}var ax=new this.constructor(N);var aq=ar._result;if(at){var aw=arguments[at-1];Y(function(){E(at,ax,aw,aq)})}else{P(ar,ax,av,au)}return ax},"catch":function(aq){return this.then(null,aq)}};function c(){var aq;if(typeof global!=="undefined"){aq=global}else{if(typeof self!=="undefined"){aq=self}else{try{aq=Function("return this")()}catch(at){throw new Error("polyfill failed because global object is unavailable in this environment")}}}var ar=aq.Promise;if(ar&&Object.prototype.toString.call(ar.resolve())==="[object Promise]"&&!ar.cast){return}aq.Promise=A}var l=c;var f={Promise:A,polyfill:l};if(typeof define==="function"&&define.amd){define(function(){return f})}else{if(typeof module!=="undefined"&&module.exports){module.exports=f}else{if(typeof this!=="undefined"){this["ES6Promise"]=f}}}l()}).call(this);